class FriendsController < ApplicationController
  def index
    list
    render :action => 'list'
  end

  # GETs should be safe (see http://www.w3.org/2001/tag/doc/whenToUseGet.html)
  verify :method => :post, :only => [ :destroy, :create, :update ],
         :redirect_to => { :action => :list }

  def list
    @friend_pages, @friends = paginate :friends, :per_page => 10
  end

  def show
    @friend = Friend.find(params[:id])
  end

  def new
    @friend = Friend.new
  end

  def create
    @friend = Friend.new(params[:friend])
    if @friend.save
      flash[:notice] = 'Friend was successfully created.'
      redirect_to :action => 'list'
    else
      render :action => 'new'
    end
  end

  def edit
    @friend = Friend.find(params[:id])
  end

  def update
    @friend = Friend.find(params[:id])
    if @friend.update_attributes(params[:friend])
      flash[:notice] = 'Friend was successfully updated.'
      redirect_to :action => 'show', :id => @friend
    else
      render :action => 'edit'
    end
  end

  def destroy
    Friend.find(params[:id]).destroy
    redirect_to :action => 'list'
  end
end
